Subject: bug#32605: [w64] (random) never returns negative

From: Eli Zaretskii <[email-masked]>
Date: Sat, 14 Aug 2021 15:36:09 +0300

> From: Andy Moreton <[email-masked]>
> Date: Sat, 14 Aug 2021 13:10:08 +0100
> 
> > Why not keep the 30 bits we produce today on 32-bit builds?
> 
> For 32bit builds (FIXNUM_BITS is 30), either:
> 
>  a) define RAND_BITS to 30, 'random' calls 'rand_as183' twice.
>     'get_random' needs 1 call to 'random' (total 2 calls of 'rand_as183').
> 
>  b) define RAND_BITS to 15, 'random' calls 'rand_as183' once.
>     'get_random' needs 2 calls to 'random' (total 2 calls of 'rand_as183').
> 
> For 64bit builds (FIXNUM_BITS is 62), either:
> 
>  a) define RAND_BITS to 30, 'random' calls 'rand_as183' twice.
>     'get_random' needs 3 calls to 'random' (total 6 calls of 'rand_as183').
> 
>  b) define RAND_BITS to 15, 'random' calls 'rand_as183' once.
>     'get_random' needs 4 calls to 'random' (total 4 calls of 'rand_as183').
> 
> On 32bit builds both options are roughly equivalent.
> On 64bit builds option (b) is better as option (a) does unnecessary work.

The above assumes we will never call 'random' except via 'get_random'.
Is that something we want to bet on?